/*
 * File:   radiofixmain.c
 * Author: Mikhail
 *
 * Created on 28 ноября 2023 г., 17:22
 */
// CONFIG
#pragma config FOSC = INTRCIO   // Oscillator Selection bits (INTOSC oscillator: I/O function on GP4/OSC2/CLKOUT pin, I/O function on GP5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = ON       // Power-Up Timer Enable bit (PWRT enabled)
#pragma config MCLRE = OFF      // GP3/MCLR pin function select (GP3/MCLR pin function is digital I/O, MCLR internally tied to VDD)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD disabled)
#pragma config CP = OFF         // Code Protection bit (Program Memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)
#define _XTAL_FREQ 4000000      // XTAL 4MHz

#include <xc.h>
#include "radiofix_header.h"
//----------------
unsigned char CheckGP0(void)  // Функция проверки состояния входа GP0
{
  unsigned char result=0;
  unsigned int butcount=0;
  while(!GP0)
  {
    if(butcount < 10000)
    {
      butcount++;
    }
    else
    {
      result = 1;
      break;
    }
  }
  return result;
}
   //------------------
void main(void) {
    ANSEL  = 0x00;       // Set ports as digital I/O, not analog input
	ADCON0 = 0x00;		 // Shut off the A/D Converter
	CMCON  = 0x07;		 // Shut off the Comparator
	VRCON  = 0x00;	     // Shut off the Voltage Reference
    TRISIO = 0x01;       // Set port GP0 as digital input
    GPIO = 0x30;         // Set ports GP4, GP5 as ,1,
  //------------------     
 __delay_ms(3000);   //Wait Задержка на выполнение программы при вкл
 //-------------------------
          // 43 канал .Радио дача. Канал по умолчанию 
         // включается при включении приёмника.
 soft_i2c_start();     //send start condition
 soft_i2c_write(0x20); //start chip 
 soft_i2c_write(0xD0); //reg  0x02 send 1-byte data  настр.0xD0
 soft_i2c_write(0x05); //send 2-byte data   0x05
 soft_i2c_write(0x0A); //reg  0x03 send 1-byte data настраивается канал 43!
 soft_i2c_write(0xD0); //send 2-byte data настраивается канал 43!
 soft_i2c_stop();      //send stop condition 
//+++++++++++++++++++++++++++
 while (1) 
  { 
 if (CheckGP0())
     {  
 chan++;  
     switch(chan)    
     {     
  case 1: {            // 26 канал
 soft_i2c_start();  
 soft_i2c_write(0x20); // далее не меняется
 soft_i2c_write(0xD0); // далее настройки регистра 02Н неизменны
 soft_i2c_write(0x05); // не меняются
 soft_i2c_write(0x06); //reg  0x03 send 1-byte data настраивается канал 26!
 soft_i2c_write(0x90); //send 2-byte data настраивается канал 26!
 soft_i2c_stop(); 
    }
 break;
  case 2: {            // 47 канал .Ретро радио.
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x0B);
 soft_i2c_write(0xD0);
 soft_i2c_stop(); 
 }
 break;
  case 3: {          // 132 .Народное радио.
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x21);
 soft_i2c_write(0x10);
 soft_i2c_stop(); 
 }
 break;
  case 4: {            // 140 канал .    .
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x23);
 soft_i2c_write(0x10);
 soft_i2c_stop(); 
 }
 break;
  case 5: {            // 177 канал .Р  радио    .
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x2C);
 soft_i2c_write(0x50);
 soft_i2c_stop(); 
 }
 break;
  case 6: {            // 190 канал .Радио НС.
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x2F);
 soft_i2c_write(0x90);
 soft_i2c_stop(); 
 }
 break;
  case 7: {            // 19 канал .Радио .
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x04);
 soft_i2c_write(0xD0);
 soft_i2c_stop(); 
 }
 break;
  case 8: {            // 200 канал .Евро Плюс.
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x32);
 soft_i2c_write(0x10);
 soft_i2c_stop(); 
 }
 break;
  case 9: {            // 205 канал .     .
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x33);
 soft_i2c_write(0x50);
 soft_i2c_stop(); 
 }
 break;
  case 10: {            // 158 канал .     .
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x27);
 soft_i2c_write(0x90);
 soft_i2c_stop(); 
 }
 break;
  case 11: {            // 165 канал .Live Radio.
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x29);
 soft_i2c_write(0x50);
 soft_i2c_stop(); 
 }
 break;
  case 12: {            // 43 канал (повторение канала по умолчанию).
 soft_i2c_start();  
 soft_i2c_write(0x20);
 soft_i2c_write(0xD0);
 soft_i2c_write(0x05);
 soft_i2c_write(0x0A);
 soft_i2c_write(0xD0);
 soft_i2c_stop(); 
 chan=0;                //Здесь переменная канала chan обнуляется 
 }                      // и выполнение передаётся case 1
default: ;
   }                    
   //----------------------------
    GP1=1; //LED ON  включаем индикаторный светодиод
    __delay_ms(1400);   //Wait
    GP1=0; //LED OFF  а тут выключаем 
   //------------------------------------    
 }
 }
    return;
}
